# encoding:utf-8
import requests


class DDbot():
    def __init__(self, webhook: str):
        self.webhook = webhook
        self.header = {
            "user-agent": "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.108 Safari/537.36",
            "Content-Type": "application/json"
        }

    # Send text message
    def Send_Text_Msg(self, Msg: str, AtMobiles: list = None, AtAll: bool = False) -> dict:
        """
        :param Msg: ͵ıϢ
        :param AtMobiles: @ҪעϢûֻ ûʽ'13888888888'ûʽ['13888888888','13999999999']
        :param AtAll: @ȫԱ
        :return:
        """
        try:
            message = {
                "msgtype": "text",
                "text": {
                    "content": Msg
                },
                "at": {
                    "atMobiles": [[Mobiles for Mobiles in AtMobiles] if isinstance(AtMobiles, list) else AtMobiles][0],
                    "isAtAll": AtAll
                }
            }
            response = requests.post(url=self.webhook, json=message, headers=self.header)
            return {"Status": response.status_code, "Msg": message}
        except Exception as error:
            raise Exception(error)

    # LinkMessage
    def Send_Link_Msg(self, Title: str, Text: str, MessageUrl: str, PicUrl: str = None) -> dict:
        """
        :param Title: 
        :param Text: 
        :param MessageUrl: url
        :param PicUrl: ͼƬurl Ϊ
        :return:
        """
        try:
            message = {
                "msgtype": "link",
                "link": {
                    "text": Text,
                    "title": Title,
                    "picUrl": PicUrl,
                    "messageUrl": MessageUrl
                }
            }
            response = requests.post(url=self.webhook, json=message, headers=self.header)
            return {"Status": response.status_code, "Msg": message}
        except Exception as error:
            raise Exception(error)

    # MarkDown
    def Send_MD_Msg(self, Title: str, Text: str, AtMobiles: list = None, AtAll: bool = False) -> dict:
        """
        :param Title: 
        :param Text: 
        :param AtMobiles:  @ҪעϢûֻ ûʽ'13888888888'ûʽ['13888888888','13999999999']
        :param AtAll: @ȫԱ
        :return:
        """
        try:
            message = {
                "msgtype": "markdown",
                "markdown": {
                    "title": Title,
                    "text": Text
                },
                "at": {
                    "atMobiles": [[Mobiles for Mobiles in AtMobiles] if isinstance(AtMobiles, list) else AtMobiles][0],
                    "isAtAll": AtAll
                }
            }
            response = requests.post(url=self.webhook, json=message, headers=self.header)
            return {"Status": response.status_code, "Msg": message}
        except Exception as error:
            raise Exception(error)

    # FeedCard
    def Send_FeedCard(self, Title: str, MessageUrl: str, PicUrl: str)->dict:
        """
        :param Title: 
        :param MessageUrl: Ϣurl
        :param PicUrl: ͼƬurl
        :return:
        """
        if isinstance(Title, str) and isinstance(PicUrl, str) and isinstance(MessageUrl, str):
            message = {
                "feedCard": {
                    "links": [
                        {
                            "title": Title,
                            "messageURL": MessageUrl,
                            "picURL": PicUrl
                        }
                    ]
                },
                "msgtype": "feedCard"
            }
        elif isinstance(Title, list) and isinstance(PicUrl, list) and isinstance(MessageUrl, list):
            message = {
                "feedCard": {
                    "links": [{"title": t, "messageURL": m, "picURL": p} for t, m, p in zip(Title, MessageUrl, PicUrl)]
                },
                "msgtype": "feedCard"
            }
        response = requests.post(url=self.webhook, json=message, headers=self.header)
        print(response.text)


if __name__ == '__main__':
    dd = DDbot(
        webhook="https://oapi.dingtalk.com/robot/send?access_token=xxxxxx")
